<template>
  <div class="row m-0 vh-100 justify-content-center align-items-center">
    <div class="col-auto p-5">
      <div class="card">
        <h1 class="card-header text-center">Heroes App</h1>
        <div class="card-body">
          <p v-if="errorMessage" class="text-danger">{{errorMessage}}</p>
          <form @submit.prevent="procesar" autocomplete="off">
            <div class="mb-3">
              <div class="input-group">
                <input type="email" class="form-control" id="correo" :class="{'is-valid': !$v.email.$invalid,'is-invalid': $v.email.$invalid}" placeholder="Correo electrónico" v-model.trim="$v.email.$model" @keypress="limpiarErrores('email')">
                <div class="input-group-append">
                  <div class="input-group-text">
                    <span class="fas fa-envelope"></span>
                  </div>
                </div>
              </div>
              <div class="text-danger" v-if="!$v.email.required">
                El campo es requerido.
              </div>
              <div class="text-danger" v-if="!$v.email.email">
                El campo debe ser una dirección de correo válida.
              </div>
              <div class="text-danger" v-for="(errorEmail, index) in errors.email" :key="index">
                {{ errorEmail }}
              </div>
            </div>
            <div class="mb-3">
              <div class="input-group">
                <input type="password" class="form-control" id="contrasena" :class="{'is-valid': !$v.pass.$invalid, 'is-invalid': $v.pass.$invalid}" placeholder="Contraseña" v-model="$v.pass.$model" @keypress="limpiarErrores('password')">
                <div class="input-group-append">
                  <div class="input-group-text">
                    <span class="fas fa-lock"></span>
                  </div>
                </div>
              </div>
              <div class="text-danger" v-if="!$v.pass.required">
                El campo es requerido.
              </div>
              <div class="text-danger" v-for="(errorPass, index) in errors.password" :key="index">
                {{ errorPass }}
              </div>
            </div>
            <button type="submit" class="btn btn-block btn-primary" :disabled="$v.$invalid || loading"><i class="fas" :class="{'fa-sign-in-alt': !loading, 'fa-spinner fa-pulse': loading}"></i> Iniciar</button>
          </form>

          <p class="mb-1 mt-3">
            <router-link to="/forget">Olvidé mi contraseña</router-link>
          </p>
          <p class="mb-1">
            <router-link to="/register" class="text-center">Registrar</router-link>
          </p>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions } from 'vuex';
import { required, email } from 'vuelidate/lib/validators';

export default {
  data () {
    return {
      email: '',
      pass: '',
      loading: false,
      errorMessage: '',
      errors: []
    }
  },
  beforeCreate () {
    if (localStorage.getItem('is_loggedin')) {
      this.$router.push({name: 'Tablero'})
    }
  },
  validations: {
    email: {
      required,
      email
    },
    pass: {
      required
    }
  },
  methods: {
    ...mapActions('usuario', ['saveToken', 'clearStorage', 'saveUsuario']),
    procesar () {
      this.loading = true
      let config = {
        headers: {
          'Accept': 'application/json'
        }
      }
      let usuario = {
        email: this.$v.email.$model,
        password: this.$v.pass.$model
      }
      this.axios.post('/auth/login', usuario, config)
        .then(res => {
          this.saveToken(res.data.body)

          config.headers.Authorization = `Bearer ${res.data.body.token}`
          this.axios.post('/auth/verify', usuario, config)
            .then(res => {
              this.loading = false
              this.saveUsuario(res.data.body.usuario)
              localStorage.setItem('is_loggedin', 'true');
              Toast.fire({
                icon: 'success',
                title: res.data.message
              })
              this.$router.push({name: 'Tablero'})
            })
            .catch(e => {
              this.loading = false
              this.clearStorage()
              this.errorMessage = e.response.data.message
              this.errors = e.response.data.body?.errores ?? []
              this.limpiarErrorMessage()
            })
        })
        .catch(e => {
          this.loading = false
          this.clearStorage()
          this.errorMessage = e.response.data.message
          this.errors = e.response.data.body?.errores ?? []
          this.limpiarErrorMessage()
        })
    },
    limpiarErrorMessage () {
      setTimeout(() => {
        this.errorMessage = ''
      }, 6000);
    },
    limpiarErrores (name) {
      delete this.errors[name]
    }
  }
}
</script>
